import { AbstractControl } from '@angular/forms';
import { FieldItems, FieldSubType, FieldType, InputType } from '../types/schema-form.types';
export declare class ParsedField {
    parent: ParsedField;
    control: AbstractControl;
    readonly default: any;
    readonly description: string;
    readonly enforceUnique: boolean;
    readonly format: FieldType;
    readonly items: FieldItems;
    readonly label: string;
    readonly options: any[];
    readonly minItems: number;
    readonly maxItems: number;
    readonly minLength: number;
    readonly maxLength: number;
    readonly minimum: number;
    readonly maximum: number;
    readonly name: string;
    readonly nestedDef: {
        [prop: string]: any;
    };
    readonly parsedArray: ParsedField[];
    readonly parsedList: ParsedField;
    readonly parsedFields: ParsedField[];
    readonly pattern: string;
    readonly properties: {
        [key: string]: any;
    };
    readonly readonly: boolean;
    readonly required: boolean;
    readonly subtype: FieldSubType;
    readonly type: FieldType;
    constructor(name: string, fieldDef: {
        [prop: string]: any;
    }, requiredFields?: string[], readonlyFields?: string[]);
    toInputType(): InputType;
}
