import { EventEmitter, OnChanges, OnDestroy } from '@angular/core';
import { SchemaForm } from '../models/SchemaForm';
import { SchemaData } from '../types/schema-form.types';
import { FieldTemplateDirective } from '../field-template/field-template.directive';
import { SchemaControl } from '../abstracts/SchemaControl';
export declare class SchemaFormComponent extends SchemaControl implements OnChanges, OnDestroy {
    schemaPayload: SchemaForm;
    readonly valueChange: EventEmitter<SchemaData>;
    fieldTemplate: FieldTemplateDirective;
    private groupSubscription;
    constructor();
    ngOnChanges(): void;
    ngOnDestroy(): void;
    /**
     * @description initializes a schema payload imperatively
     */
    initSchemaForm(schemaForm: SchemaForm): void;
    protected initGroup(): void;
}
